-- TAD ÁrbolBinario

module TADArbolBinario(ArbolBinario,vacío,nodo,es_vacío,raíz,izquierdo,derecho,altura) where

-- CONSTRUCTORES

data ArbolBinario e = Vacío
                    | Nodo (ArbolBinario e) e (ArbolBinario e)
                    deriving Eq

vacío = Vacío
nodo = Nodo

-- OPERACIONES

es_vacío :: ArbolBinario e -> Bool
raíz :: ArbolBinario e -> e                -- se aplica solo a un árbol no Vacío
izquierdo :: ArbolBinario e -> ArbolBinario e   -- idem
derecho :: ArbolBinario e -> ArbolBinario e     -- idem

-- ECUACIONES

es_vacío Vacío = True
es_vacío (Nodo i r d) = False

raíz Vacío = error "No se puede obtener la raíz del árbol vacío"
raíz (Nodo i r d) = r

izquierdo Vacío = error "No se puede obtener el subárbol izquierdo del árbol vacío"
izquierdo (Nodo i r d) = i

derecho Vacío = error "No se puede obtener el subárbol derecho del árbol vacío"
derecho (Nodo i r d) = d

altura :: ArbolBinario e -> Int
altura Vacío = -1   -- otra definición: altura Vacío = 0
altura (Nodo i r d) = 1 + altura i `max` altura d

instance Show e => Show (ArbolBinario e) where
  show Vacío = "<>"
  show (Nodo Vacío r Vacío) = "<" ++ show r ++ ">"
  show (Nodo i r d) = "<" ++ show i ++ "," ++ show r ++ "," ++ show d ++ ">"

